'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRouter = require('react-router');

var _immutable = require('immutable');

var _immutable2 = _interopRequireDefault(_immutable);

var _RecordButtonBar = require('./RecordButtonBar');

var _RecordButtonBar2 = _interopRequireDefault(_RecordButtonBar);

var _RecordHeader = require('./RecordHeader');

var _RecordHeader2 = _interopRequireDefault(_RecordHeader);

var _ConfirmRecordNavigationModal = require('./ConfirmRecordNavigationModal');

var _ConfirmRecordNavigationModal2 = _interopRequireDefault(_ConfirmRecordNavigationModal);

var _ConfirmRecordDeleteModal = require('./ConfirmRecordDeleteModal');

var _ConfirmRecordDeleteModal2 = _interopRequireDefault(_ConfirmRecordDeleteModal);

var _RecordFormContainer = require('../../containers/record/RecordFormContainer');

var _RecordFormContainer2 = _interopRequireDefault(_RecordFormContainer);

var _RecordEditor = require('../../../styles/cspace-ui/RecordEditor.css');

var _RecordEditor2 = _interopRequireDefault(_RecordEditor);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var propTypes = {
  config: _propTypes2.default.object,
  recordType: _propTypes2.default.string.isRequired,
  vocabulary: _propTypes2.default.string,
  csid: _propTypes2.default.string,
  cloneCsid: _propTypes2.default.string,
  data: _propTypes2.default.instanceOf(_immutable2.default.Map),
  dockTop: _propTypes2.default.number,
  formName: _propTypes2.default.string,
  validationErrors: _propTypes2.default.instanceOf(_immutable2.default.Map),
  isModified: _propTypes2.default.bool,
  isSavePending: _propTypes2.default.bool,
  openModalName: _propTypes2.default.string,
  createNewRecord: _propTypes2.default.func,
  readRecord: _propTypes2.default.func,
  onRecordCreated: _propTypes2.default.func,
  onSaveCancelled: _propTypes2.default.func,
  closeModal: _propTypes2.default.func,
  openModal: _propTypes2.default.func,
  save: _propTypes2.default.func,
  revert: _propTypes2.default.func,
  clone: _propTypes2.default.func,
  transitionRecord: _propTypes2.default.func,
  removeValidationNotification: _propTypes2.default.func,
  setForm: _propTypes2.default.func,
  validateRecordData: _propTypes2.default.func,
  onRecordTransitioned: _propTypes2.default.func
};

var defaultProps = {
  data: _immutable2.default.Map(),
  formName: 'default'
};

var RecordEditor = function (_Component) {
  _inherits(RecordEditor, _Component);

  function RecordEditor() {
    _classCallCheck(this, RecordEditor);

    var _this = _possibleConstructorReturn(this, (RecordEditor.__proto__ || Object.getPrototypeOf(RecordEditor)).call(this));

    _this.handleConfirmDeleteButtonClick = _this.handleConfirmDeleteButtonClick.bind(_this);

    _this.handleConfirmNavigationSaveButtonClick = _this.handleConfirmNavigationSaveButtonClick.bind(_this);

    _this.handleConfirmNavigationRevertButtonClick = _this.handleConfirmNavigationRevertButtonClick.bind(_this);

    _this.handleModalCancelButtonClick = _this.handleModalCancelButtonClick.bind(_this);
    _this.handleSaveButtonClick = _this.handleSaveButtonClick.bind(_this);
    _this.handleSaveButtonErrorBadgeClick = _this.handleSaveButtonErrorBadgeClick.bind(_this);
    _this.handleRevertButtonClick = _this.handleRevertButtonClick.bind(_this);
    _this.handleCloneButtonClick = _this.handleCloneButtonClick.bind(_this);
    _this.handleDeleteButtonClick = _this.handleDeleteButtonClick.bind(_this);
    _this.handleRecordFormSelectorCommit = _this.handleRecordFormSelectorCommit.bind(_this);
    return _this;
  }

  _createClass(RecordEditor, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.initRecord();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      var _props = this.props,
          recordType = _props.recordType,
          vocabulary = _props.vocabulary,
          csid = _props.csid,
          cloneCsid = _props.cloneCsid;
      var prevRecordType = prevProps.recordType,
          prevVocabulary = prevProps.vocabulary,
          prevCsid = prevProps.csid,
          prevCloneCsid = prevProps.cloneCsid;


      if (recordType !== prevRecordType || vocabulary !== prevVocabulary || csid !== prevCsid || cloneCsid !== prevCloneCsid) {
        this.initRecord();
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      var removeValidationNotification = this.props.removeValidationNotification;


      if (removeValidationNotification) {
        removeValidationNotification();
      }
    }
  }, {
    key: 'initRecord',
    value: function initRecord() {
      var _props2 = this.props,
          csid = _props2.csid,
          cloneCsid = _props2.cloneCsid,
          createNewRecord = _props2.createNewRecord,
          readRecord = _props2.readRecord,
          removeValidationNotification = _props2.removeValidationNotification;


      if (removeValidationNotification) {
        removeValidationNotification();
      }

      if (csid) {
        if (readRecord) {
          readRecord();
        }
      } else if (createNewRecord) {
        createNewRecord(cloneCsid);
      }
    }
  }, {
    key: 'handleModalCancelButtonClick',
    value: function handleModalCancelButtonClick() {
      var _props3 = this.props,
          closeModal = _props3.closeModal,
          onSaveCancelled = _props3.onSaveCancelled;


      if (closeModal) {
        closeModal(false);
      }

      if (onSaveCancelled) {
        onSaveCancelled();
      }
    }
  }, {
    key: 'handleConfirmDeleteButtonClick',
    value: function handleConfirmDeleteButtonClick() {
      var _props4 = this.props,
          closeModal = _props4.closeModal,
          transitionRecord = _props4.transitionRecord,
          onRecordTransitioned = _props4.onRecordTransitioned;


      var transitionName = 'delete';

      if (transitionRecord) {
        transitionRecord(transitionName).then(function () {
          if (closeModal) {
            closeModal(true);
          }

          if (onRecordTransitioned) {
            onRecordTransitioned(transitionName);
          }
        });
      }
    }
  }, {
    key: 'handleConfirmNavigationSaveButtonClick',
    value: function handleConfirmNavigationSaveButtonClick() {
      var _props5 = this.props,
          closeModal = _props5.closeModal,
          save = _props5.save,
          onRecordCreated = _props5.onRecordCreated;


      if (save) {
        // Wrap the onRecordCreated callback in a function that sets isNavigating to true. This lets
        // the callback know that we're already navigating away, so it should not do any navigation
        // of its own.

        var callback = onRecordCreated ? function (newRecordCsid) {
          onRecordCreated(newRecordCsid, true);
        } : undefined;

        save(callback);
      }

      if (closeModal) {
        closeModal(true);
      }
    }
  }, {
    key: 'handleConfirmNavigationRevertButtonClick',
    value: function handleConfirmNavigationRevertButtonClick() {
      var _props6 = this.props,
          closeModal = _props6.closeModal,
          revert = _props6.revert;


      if (revert) {
        revert();
      }

      if (closeModal) {
        closeModal(true);
      }
    }
  }, {
    key: 'handleCloneButtonClick',
    value: function handleCloneButtonClick() {
      var _props7 = this.props,
          clone = _props7.clone,
          csid = _props7.csid;


      if (clone) {
        clone(csid);
      }
    }
  }, {
    key: 'handleDeleteButtonClick',
    value: function handleDeleteButtonClick() {
      var openModal = this.props.openModal;


      if (openModal) {
        openModal(_ConfirmRecordDeleteModal2.default.modalName);
      }
    }
  }, {
    key: 'handleRevertButtonClick',
    value: function handleRevertButtonClick() {
      var revert = this.props.revert;


      if (revert) {
        revert();
      }
    }
  }, {
    key: 'handleSaveButtonClick',
    value: function handleSaveButtonClick() {
      var _props8 = this.props,
          save = _props8.save,
          onRecordCreated = _props8.onRecordCreated;


      if (save) {
        save(onRecordCreated);
      }
    }
  }, {
    key: 'handleSaveButtonErrorBadgeClick',
    value: function handleSaveButtonErrorBadgeClick() {
      var validateRecordData = this.props.validateRecordData;


      if (validateRecordData) {
        validateRecordData();
      }
    }
  }, {
    key: 'handleRecordFormSelectorCommit',
    value: function handleRecordFormSelectorCommit(path, value) {
      var setForm = this.props.setForm;


      if (setForm) {
        setForm(value);
      }
    }
  }, {
    key: 'renderConfirmNavigationModal',
    value: function renderConfirmNavigationModal() {
      var _props9 = this.props,
          isModified = _props9.isModified,
          isSavePending = _props9.isSavePending,
          openModalName = _props9.openModalName,
          validationErrors = _props9.validationErrors;


      return _react2.default.createElement(_ConfirmRecordNavigationModal2.default, {
        isOpen: openModalName === _ConfirmRecordNavigationModal2.default.modalName,
        isModified: isModified,
        isSavePending: isSavePending,
        validationErrors: validationErrors,
        onCancelButtonClick: this.handleModalCancelButtonClick,
        onCloseButtonClick: this.handleModalCancelButtonClick,
        onSaveButtonClick: this.handleConfirmNavigationSaveButtonClick,
        onSaveButtonErrorBadgeClick: this.handleSaveButtonErrorBadgeClick,
        onRevertButtonClick: this.handleConfirmNavigationRevertButtonClick
      });
    }
  }, {
    key: 'renderConfirmRecordDeleteModal',
    value: function renderConfirmRecordDeleteModal() {
      var _props10 = this.props,
          csid = _props10.csid,
          isSavePending = _props10.isSavePending,
          openModalName = _props10.openModalName;


      return _react2.default.createElement(_ConfirmRecordDeleteModal2.default, {
        csid: csid,
        isOpen: openModalName === _ConfirmRecordDeleteModal2.default.modalName,
        isSavePending: isSavePending,
        onCancelButtonClick: this.handleModalCancelButtonClick,
        onCloseButtonClick: this.handleModalCancelButtonClick,
        onDeleteButtonClick: this.handleConfirmDeleteButtonClick
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props11 = this.props,
          config = _props11.config,
          csid = _props11.csid,
          data = _props11.data,
          dockTop = _props11.dockTop,
          formName = _props11.formName,
          isModified = _props11.isModified,
          isSavePending = _props11.isSavePending,
          recordType = _props11.recordType,
          validationErrors = _props11.validationErrors;


      var recordTypeConfig = config.recordTypes[recordType];

      if (!recordTypeConfig) {
        return null;
      }

      return _react2.default.createElement(
        'form',
        { className: _RecordEditor2.default.common, autoComplete: 'off' },
        _react2.default.createElement(_RecordHeader2.default, {
          csid: csid,
          isModified: isModified,
          isSavePending: isSavePending,
          validationErrors: validationErrors,
          onSaveButtonClick: this.handleSaveButtonClick,
          onSaveButtonErrorBadgeClick: this.handleSaveButtonErrorBadgeClick,
          onRevertButtonClick: this.handleRevertButtonClick,
          onCloneButtonClick: this.handleCloneButtonClick,
          onDeleteButtonClick: this.handleDeleteButtonClick,
          config: config,
          formName: formName,
          recordType: recordType,
          onCommit: this.handleRecordFormSelectorCommit,
          data: data,
          dockTop: dockTop
        }),
        _react2.default.createElement(_RecordFormContainer2.default, {
          config: config,
          csid: csid,
          data: data,
          formName: formName,
          recordType: recordType
        }),
        _react2.default.createElement(
          'footer',
          null,
          _react2.default.createElement(_RecordButtonBar2.default, {
            csid: csid,
            isModified: isModified,
            isSavePending: isSavePending,
            validationErrors: validationErrors,
            onSaveButtonClick: this.handleSaveButtonClick,
            onSaveButtonErrorBadgeClick: this.handleSaveButtonErrorBadgeClick,
            onRevertButtonClick: this.handleRevertButtonClick,
            onCloneButtonClick: this.handleCloneButtonClick,
            onDeleteButtonClick: this.handleDeleteButtonClick
          })
        ),
        _react2.default.createElement(_reactRouter.Prompt, {
          when: isModified && !isSavePending,
          message: _ConfirmRecordNavigationModal2.default.modalName
        }),
        this.renderConfirmNavigationModal(),
        this.renderConfirmRecordDeleteModal()
      );
    }
  }]);

  return RecordEditor;
}(_react.Component);

exports.default = RecordEditor;


RecordEditor.propTypes = propTypes;
RecordEditor.defaultProps = defaultProps;