'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _reactIntl = require('react-intl');

var _cspaceRefname = require('cspace-refname');

var _formatHelpers = require('../../../helpers/formatHelpers');

exports.default = {
  default: [{
    name: 'movementReferenceNumber',
    messages: (0, _reactIntl.defineMessages)({
      label: {
        'id': 'column.movement.default.movementReferenceNumber',
        'defaultMessage': 'Reference number'
      }
    }),
    sortBy: 'movements_common:movementReferenceNumber',
    width: 250
  }, {
    name: 'currentLocation',
    messages: (0, _reactIntl.defineMessages)({
      label: {
        'id': 'column.movement.default.currentLocation',
        'defaultMessage': 'Current location'
      }
    }),
    formatValue: function formatValue(value) {
      return (0, _cspaceRefname.getDisplayName)(value);
    },
    sortBy: 'movements_common:currentLocation',
    width: 400
  }, {
    name: 'updatedAt',
    messages: (0, _reactIntl.defineMessages)({
      label: {
        'id': 'column.movement.default.updatedAt',
        'defaultMessage': 'Updated'
      }
    }),
    formatValue: _formatHelpers.formatTimestamp,
    sortBy: 'collectionspace_core:updatedAt',
    width: 150
  }]
};